IMPLEMENTATION MODULE MRepo;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
IMPORT FIO;
IMPORT Window;
IMPORT IO;
FROM MCadena IMPORT MAXCAD,TCadena,IgualCadena;
TYPE
   TAlg = POINTER TO Datos;
   Datos = 	RECORD
   		     nom:TCadena;
                     leng:TCadena;
   		     sig:TAlg;
   			END;
   TRepositorio = POINTER TO TComp;
   TComp  = RECORD
   				cmp:TCadena;
   				alg:TAlg;
		   		sig:TRepositorio;
   	     END;	

(*PROCEDIMIENTO LOCAL: Hace una copia de la primera cadena;
  NOTA: YO PERMITO LA ASIGNACION DE CADENAS, ASI QUE ESTE
        PROCEDIMIENTO NO ES NECESARIO. AUN ASI ME PARECE
        INTERESANTE MOSTRAR SU IMPLEMENTACION*)

PROCEDURE CopiarCad(cad1:ARRAY OF CHAR;VAR cad2:ARRAY OF CHAR);
VAR
	i:CARDINAL;	
BEGIN
	i:=0;
	WHILE (i <= HIGH(cad1)) AND (i <= HIGH(cad2)) AND
	       (cad1[i] <> CHR(0)) DO
		cad2[i]:=cad1[i];
		INC(i);
	END;
	IF (i <= HIGH(cad2)) THEN
		 cad2[i]:=CHR(0);
	END;
	
END CopiarCad;

PROCEDURE Pulsar(); (*Realiza una pausa*)
VAR
	c:CHAR;
BEGIN
	IO.WrLn;
	IO.WrStr('Pulsar una tecla......');
	IO.RdLn;
	c:=IO.RdKey();
	IO.WrLn;
END Pulsar;



(*Busca la posicion en la que esta el componente*)
PROCEDURE BuscaPosiComp(r:TRepositorio;cmp:TCadena;VAR posi,posiret:TRepositorio);
BEGIN
	posiret:=NIL;
	posi:= r;
	WHILE (posi <> NIL) AND NOT(IgualCadena(cmp,posi^.cmp)) DO
			posiret:=posi;
			posi:=posi^.sig;
	END;
END BuscaPosiComp;



PROCEDURE CrearRepositorio ():TRepositorio;
BEGIN
	RETURN(NIL);
END CrearRepositorio;
(* Crea un Repositorio vaco *)


PROCEDURE RepositorioVacio(r:TRepositorio):BOOLEAN;
BEGIN
	RETURN(r = NIL);
END RepositorioVacio;
(* Nos dice si un Repositorio est vaco *)


PROCEDURE RepositorioLleno(r:TRepositorio):BOOLEAN;
BEGIN
		RETURN(NOT(Available(SIZE(TComp))));
END RepositorioLleno;
(* Nos dice si un Repositorio est lleno *)

PROCEDURE InsComponente(VAR r:TRepositorio; cmp:TCadena;VAR ok:BOOLEAN);
VAR
	temp:TRepositorio;
BEGIN
	ok:=BuscarComponente(r,cmp);
	IF NOT ok THEN
	   IF NOT RepositorioLleno(r) THEN
		NEW(temp);
		CopiarCad(cmp,temp^.cmp);
		temp^.alg:=NIL;
		temp^.sig:=r;
		r:=temp
	   ELSE
	        ok:=FALSE
	   END;
	END;	
END InsComponente;
(* Inserta un componente software en el Repositorio *)

PROCEDURE InsAlgoritmo(VAR r:TRepositorio; cmp,alg,leng:TCadena;VAR ok:BOOLEAN);
VAR
	temp:TAlg;
	aux,auxret:TRepositorio;
BEGIN
                ok:=TRUE;
		IF BuscarComponente(r,cmp) AND Available(SIZE(Datos)) THEN
				BuscaPosiComp(r,cmp,aux,auxret);
				NEW(temp);
				CopiarCad(alg,temp^.nom);
				CopiarCad(leng,temp^.leng);
				temp^.sig:=aux^.alg;
				aux^.alg:= temp;
		ELSE
		  ok:=FALSE
		END;
END InsAlgoritmo;
(* Inserta un algoritmo en el Repositorio. Si el componente no est
   insertado, NO lo insertar *)

PROCEDURE BorrarAlgoritmos(VAR repo:TRepositorio);
VAR
  aux:TAlg;
BEGIN
	  aux:=repo^.alg;
	  WHILE (aux <> NIL) DO
	  			repo^.alg:=aux^.sig;
	  			DISPOSE(aux);
	  			aux:=repo^.alg;
	  END;
END BorrarAlgoritmos;

PROCEDURE BorrarComponente(VAR r:TRepositorio; cmp:TCadena; VAR ok:BOOLEAN );
VAR
	aux,auxret:TRepositorio;
BEGIN
	 ok:=FALSE;	
	 BuscaPosiComp(r,cmp,aux,auxret);	
         IF aux <> NIL THEN
       	   IF auxret = NIL THEN
      	  		r:=aux^.sig;
      	   ELSE
      	  		auxret^.sig:=aux^.sig;
      	   END;
      	   BorrarAlgoritmos(aux);
      	   DISPOSE(aux);
      	   ok:=TRUE;
         END;
END BorrarComponente;
(* Borra un componente y todos sus algoritmos del Repositorio *)

PROCEDURE BuscarComponente(r:TRepositorio; cmp:TCadena):BOOLEAN;
VAR
	aux:TRepositorio;
BEGIN
		aux:= r;
		WHILE (aux <> NIL) AND (NOT (IgualCadena(cmp,aux^.cmp))) DO
				aux:=aux^.sig;
		END;
		RETURN(aux<>NIL);
END BuscarComponente;

(* Nos dice si un componente est en el Repositorio *)

PROCEDURE PintarComponente(r:TRepositorio; cmp:TCadena);
VAR
	aux1,aux1ret:TRepositorio;
	aux2:TAlg;
	i:CARDINAL;
BEGIN
    BuscaPosiComp(r,cmp,aux1,aux1ret);
    Window.Clear;
    IO.WrStr(aux1^.cmp);IO.WrLn;
    IO.WrStr('-------------');IO.WrLn;
    aux2:=aux1^.alg;
    i:=1;
    WHILE (aux2 <> NIL) DO
        IO.WrCard(i,0);IO.WrStr('. ');
  	IO.WrStr('NOMBRE:');
     	IO.WrStr(aux2^.nom);IO.WrLn;
     	IO.WrStr('   LENGUAJE:');
     	IO.WrStr(aux2^.leng);IO.WrLn;
     	INC(i);
     	aux2:=aux2^.sig;
     	IF i>20 THEN
     	   i:=1;
     	   Pulsar;
     	   Window.Clear;
     	END;
     END;
     IO.WrLn;
     Pulsar; IO.WrLn;
END PintarComponente;
(* Pinta por pantalla todos los algoritmos de un
   componente del Repositorio *)

PROCEDURE PintarRepositorio(r:TRepositorio);
VAR
	aux1:TRepositorio;
	aux2:TAlg;
	i:CARDINAL;
BEGIN
		aux1:= r;
		WHILE (aux1 <> NIL) DO		
		        IO.WrLn;
			IO.WrStr('COMPONENTE:');
			IO.WrStr(aux1^.cmp);IO.WrLn;IO.WrLn;
			IO.WrStr('       ALGORITMOS');IO.WrLn;
			IO.WrStr('=================================');
			IO.WrLn;
			aux2:=aux1^.alg;
			i:=1;
			WHILE (aux2 <> NIL) DO
				IO.WrCard(i,0);IO.WrChar('.');
				IO.WrStr(aux2^.nom);
				IO.WrStr('    Lenguaje:');IO.WrStr(aux2^.leng);IO.WrLn;
				INC(i);
				aux2:=aux2^.sig;
				IF i>20 THEN
                          	   i:=1;
                         	   Pulsar;
                         	   Window.Clear;
                         	END;
			END;
			Pulsar;
			aux1:=aux1^.sig;
		END;		
END PintarRepositorio;

(* Pinta por pantalla TODOS los componentes y sus
   algortimos del Repositorio *)

PROCEDURE PintarLenguaje(r:TRepositorio;leng:TCadena);
VAR
	aux1:TRepositorio;
	aux2:TAlg;
	i:CARDINAL;
BEGIN
     aux1:=r;
     Window.Clear;
     WHILE (aux1 <> NIL) DO
     	aux2:=aux1^.alg;
     	WHILE (aux2 <> NIL) DO
     		IF IgualCadena(leng,aux2^.leng) THEN
     			IO.WrStr('   COMPONENTE:');
     			IO.WrStr(aux1^.cmp);
     			IO.WrStr('   NOMBRE:');
     			IO.WrStr(aux2^.nom);IO.WrLn;
     			INC(i);
     			IF i>20 THEN
                          	   i:=1;
                         	   Pulsar;
                         	   Window.Clear;
                        END;
     		END;
     		aux2:=aux2^.sig;
     	END;
     	aux1:=aux1^.sig;
     END;
END PintarLenguaje;
(* Pinta por pantalla TODOS los algoritmos de TODOS los componentes
   implementados en un determinado lenguaje *)

PROCEDURE CalcularNumAlg(aux1:TRepositorio):CARDINAL ;
VAR
	num:CARDINAL;
	aux:TAlg;
BEGIN
	num:= 0;
	aux:=aux1^.alg;
	WHILE (aux <> NIL ) DO
	  aux:=aux^.sig;
	  INC(num);
	END;
	RETURN(num);
END CalcularNumAlg;

PROCEDURE SalvarRepositorio(r:TRepositorio; fichero:TCadena);
VAR
   f:FIO.File;
   aux1:TRepositorio;
   aux2:TAlg;
   num,i:CARDINAL;
BEGIN
	f:=FIO.Create(fichero);
	aux1:=r;
	WHILE (aux1 <> NIL) DO
		FIO.WrStr(f,aux1^.cmp);FIO.WrChar(f,' ');
		num:=CalcularNumAlg(aux1);
		FIO.WrCard(f,num,0);FIO.WrChar(f,' ');
		aux2:=aux1^.alg;
		FOR i:=1 TO num DO
			FIO.WrStr(f,aux2^.nom);FIO.WrChar(f,' ');
			FIO.WrStr(f,aux2^.leng);FIO.WrChar(f,' ');
			aux2:=aux2^.sig;
		END;
		FIO.WrLn(f);
		aux1:=aux1^.sig;
	END;
	FIO.Close(f);
END SalvarRepositorio;
(* Salva el Repositorio en un fichero de texto *)

PROCEDURE DestruirRepositorio (VAR r:TRepositorio);
VAR
	aux1:TRepositorio;
	aux2:TAlg;
BEGIN
	aux1:= r;
	WHILE (aux1 <> NIL) DO
		aux2:=aux1^.alg;
		WHILE (aux2 <> NIL) DO
			aux1^.alg:=aux2^.sig;
			DISPOSE(aux2);
			aux2:=aux1^.alg;
		END;
		r:=aux1^.sig;
		DISPOSE(aux1);
		aux1:=r;
	END;	
END DestruirRepositorio;
(*Destruye el repositorio*)
END MRepo.